// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/utils/util_usc_tx_ctrl_block.c $
// $Rev: 18354 $
// $Date: 2012-10-11 07:21:03 -0500 (Thu, 11 Oct 2012) $

#include "sio4_utils.h"



/******************************************************************************
*
*	Function:	sio4_usc_tx_ctrl_block
*
*	Purpose:
*
*		Provide a visual wrapper for the SIO4_IOCTL_USC_TX_CTRL_BLOCK service.
*
*	Arguments:
*
*		fd		The handle to use to access the driver.
*
*		index	The index of the board to access. Ignore if < 0.
*
*		verbose	0: errors only, !0: all output
*
*		set		This is the value to apply.
*
*		get		The results are reported here. This may be NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int sio4_usc_tx_ctrl_block(int fd, int index, int verbose, s32 set, s32* get)
{
	char		buf[128];
	int			errs;
	const char*	ptr;

	if (verbose)
		gsc_label_index("USC Tx Control Block", index);

	errs	= sio4_dsl_ioctl(fd, SIO4_IOCTL_USC_TX_CTRL_BLOCK, &set);

	switch (set)
	{
		default:

			errs++;
			ptr	= buf;
			sprintf(buf, "Unrecognized option: 0x%lX", (long) set);
			break;

		case -1:

			ptr	= "This service is not supported by this board.";
			break;

		case SIO4_USC_CTRL_BLOCK_NO:

			ptr	= "No, None";
			break;

		case SIO4_USC_CTRL_BLOCK_1_WORD:

			ptr	= "Yes, 1-word sized";
			break;

		case SIO4_USC_CTRL_BLOCK_2_WORD:

			ptr	= "Yes, 2-word sized";
			break;
	}

	if (verbose)
		printf("%s  (%s)\n", errs ? "FAIL <---" : "PASS", ptr);

	if (get)
		get[0]	= set;

	return(errs);
}


